/**
  ******************************************************************************
  * @file    fm33a0xx_pmu.c
  * @author  FM33a0xx Application Team
  * @version V3.00
  * @date    
  * @brief   
  *
*/

/* Includes ------------------------------------------------------------------*/
#include "fm33A0xx_pmu.h" 

/** @addtogroup fm33a0xx_StdPeriph_Driver
  * @{
  */

/** @defgroup PMU 
  * @brief PMU driver modules
  * @{
  */ 

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/

/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/


/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

/** @defgroup PMU_Private_Functions
  * @{
  */


//Code_Start
//2018-04-02-13-22-03
//FM33A0XX_Driver_Gen_V1.4

/********************************
رXTLF
:رXTLFSLEEP/DEEPSLEEP
룺رXTLF״̬
 ********************************/
void PMU_LPMCFG_XTOFF_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = PMU->LPMCFG;
	tmpreg &= ~(PMU_LPMCFG_XTOFF_Msk);
	tmpreg |= (SetValue & PMU_LPMCFG_XTOFF_Msk);
	PMU->LPMCFG = tmpreg;
}
/********************************
ȡرXTLF״̬
:ȡرXTLF״̬
رXTLF״̬
 ********************************/
uint32_t PMU_LPMCFG_XTOFF_Get(void)
{
	return (PMU->LPMCFG & PMU_LPMCFG_XTOFF_Msk);
}

/********************************
ȡLDO15ʹ״̬
:ȡLDO15ʹ״̬
LDO15ʹ״̬
 ********************************/
FlagStatus PMU_LPMCFG_LDO15EN_Chk(void)
{
	if (PMU->LPMCFG & PMU_LPMCFG_LDO15EN_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}
/********************************
DeepSleepģʽRAMݱú
:DeepSleepģʽRAMݱ
룺DeepSleepģʽRAMǷ񱣳ֵ
 ********************************/
void PMU_LPMCFG_DSLPRAM_EXT_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = PMU->LPMCFG;
	tmpreg &= ~(PMU_LPMCFG_DSLPRAM_EXT_Msk);
	tmpreg |= (SetValue & PMU_LPMCFG_DSLPRAM_EXT_Msk);
	PMU->LPMCFG = tmpreg;
}
/********************************
ȡDeepSleepģʽRAMݱüĴĺ
:ȡDeepSleepģʽRAMݱüĴ
룺DeepSleepģʽRAMǷ񱣳ֵ
 ********************************/
uint32_t PMU_LPMCFG_DSLPRAM_EXT_Get(void)
{
	return (PMU->LPMCFG & PMU_LPMCFG_DSLPRAM_EXT_Msk);
}

/********************************
DeepSleepƺ
:ǷDeepSleepSleepЧ
룺ǷDeepSleep
 ********************************/
void PMU_LPMCFG_SLPDP_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = PMU->LPMCFG;
	tmpreg &= ~(PMU_LPMCFG_SLPDP_Msk);
	tmpreg |= (SetValue & PMU_LPMCFG_SLPDP_Msk);
	PMU->LPMCFG = tmpreg;
}
/********************************
ȡDeepSleepú
:ǷDeepSleep
ǷDeepSleep
 ********************************/
uint32_t PMU_LPMCFG_SLPDP_Get(void)
{
	return (PMU->LPMCFG & PMU_LPMCFG_SLPDP_Msk);
}
/********************************
͹ģʽں˵ѹƺ
:õ͹ģʽں˵ѹĿرգλSleep/DeepSleep
룺͹ģʽں˵ѹص
 ********************************/
void PMU_LPMCFG_CVS_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		PMU->LPMCFG |= (PMU_LPMCFG_CVS_Msk);
	}
	else
	{
		PMU->LPMCFG &= ~(PMU_LPMCFG_CVS_Msk);
	}
}
/********************************
ȡԵ͹ģʽں˵ѹƺ
:͹ģʽں˵ѹĿرյ
͹ģʽں˵ѹĿر״̬
 ********************************/
FunState PMU_LPMCFG_CVS_Getable(void)
{
	if (PMU->LPMCFG & (PMU_LPMCFG_CVS_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
͹ģʽú
:Ե͹ģʽ
룺͹ģʽ
 ********************************/
void PMU_LPMCFG_PMOD_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = PMU->LPMCFG;
	tmpreg &= ~(PMU_LPMCFG_PMOD_Msk);
	tmpreg |= (SetValue & PMU_LPMCFG_PMOD_Msk);
	PMU->LPMCFG = tmpreg;
}
/********************************
ȡ͹ģʽú
:ȡ͹ģʽ
͹ģʽ
 ********************************/
uint32_t PMU_LPMCFG_PMOD_Get(void)
{
	return (PMU->LPMCFG & PMU_LPMCFG_PMOD_Msk);
}

/********************************
ʱƺ
:BGʹܵLDOʼȡFlashʱ
룺ʱֵ
 ********************************/
void PMU_WKDLYCON_TRHR_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = PMU->WKDLYCON;
	tmpreg &= ~(PMU_WKDLYCON_TRHR_Msk);
	tmpreg |= (SetValue & PMU_WKDLYCON_TRHR_Msk);
	PMU->WKDLYCON = tmpreg;
}
/********************************
ȡʱ亯
:ȡBGʹܵLDOʼȡFlashʱ
ʱֵ
 ********************************/
uint32_t PMU_WKDLYCON_TRHR_Get(void)
{
	return (PMU->WKDLYCON & PMU_WKDLYCON_TRHR_Msk);
}

/********************************
CPU Debuggerѱ־
:CPU Debuggerѱ־
 ********************************/
void PMU_WKPFLAG_DBGWKF_Clr(void)
{
	PMU->WKPFLAG = PMU_WKPFLAG_DBGWKF_Msk;
}
/********************************
ȡCPU Debuggerѱ־
:ȡCPU Debuggerѱ־
CPU Debuggerѱ־
 ********************************/
FlagStatus PMU_WKPFLAG_DBGWKF_Chk(void)
{
	if (PMU->WKPFLAG & PMU_WKPFLAG_DBGWKF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}


/********************************
SLEEPжʹܺ
:SLEEPжʹ
룺SLEEPжʹܵ
 ********************************/
void PMU_LPREIE_SLPEIE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		PMU->LPREIE |= (PMU_LPREIE_SLPEIE_Msk);
	}
	else
	{
		PMU->LPREIE &= ~(PMU_LPREIE_SLPEIE_Msk);
	}
}
/********************************
ȡSLEEPжʹܺ
:ȡSLEEPжʹܵ
SLEEPжʹܵ
 ********************************/
FunState PMU_LPREIE_SLPEIE_Getable(void)
{
	if (PMU->LPREIE & (PMU_LPREIE_SLPEIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}


/********************************
LPRUNжʹܺ
:LPRUNжʹ
룺LPRUNжʹܵ
 ********************************/
void PMU_LPREIE_LPREIE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		PMU->LPREIE |= (PMU_LPREIE_LPREIE_Msk);
	}
	else
	{
		PMU->LPREIE &= ~(PMU_LPREIE_LPREIE_Msk);
	}
}
/********************************
ȡ LPRUNжʹܺ
:ȡ LPRUNжʹܵ
 LPRUNжʹܵ
 ********************************/
FunState PMU_LPREIE_LPREIE_Getable(void)
{
	if (PMU->LPREIE & (PMU_LPREIE_LPREIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/* SLEEPжϱ־Ӳλд1,PMOD=2h2CPUִWFI/WFEָǰλSLEEPDEEPĴʱλ غ */
/********************************
 SLEEPжϱ־
:SLEEPжϱ־
********************************/
void PMU_LPREIF_SLPEIF_Clr(void)
{
	PMU->LPREIF = PMU_LPREIF_SLPEIF_Msk;
}
/********************************
ȡSLEEPжϱ־
:ȡSLEEPжϱ־
 SLEEPжϱ־
 ********************************/
FlagStatus PMU_LPREIF_SLPEIF_Chk(void)
{
	if (PMU->LPREIF & PMU_LPREIF_SLPEIF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/* LPRUNжϱ־Ӳλд1㣻LPRUNģʽʱLPREIFоƬԽͣACTIVEģʽ,LPRUN Condition ErrorLPRUNʱ
1 HSCLKѡLSCLKRCLP
2 RCHFPLLADCʹδر
 غ */
void PMU_LPREIF_LPREIF_Clr(void)
{
	PMU->LPREIF = PMU_LPREIF_LPREIF_Msk;
}

FlagStatus PMU_LPREIF_LPREIF_Chk(void)
{
	if (PMU->LPREIF & PMU_LPREIF_LPREIF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}


void PMU_Deinit(void)
{
	PMU->LPMCFG = 0x00060000;
	PMU->WKDLYCON = 0x00000001;
	//PMU->WKPFLAG = 0x00000000;
	PMU->LPREIE = 0x00000000;
	//PMU->LPREIF = 0x00000000;
}
//Code_End		

///* WKUPʹPIN궨 */
//GPIO.h
//#define		PINWKEN_PD6		BIT7
//#define		PINWKEN_PE9		BIT6
//#define		PINWKEN_PE2		BIT5
//#define		PINWKEN_PA13	BIT4
//#define		PINWKEN_PG7		BIT3
//#define		PINWKEN_PC13	BIT2
//#define		PINWKEN_PB0		BIT1
//#define		PINWKEN_PF5		BIT0
/********************************
NWKUPx Pinѱ־
:NWKUPx Pinѱ־Sleep/DeepSleepģʽЧ
룺NWKUPx Pinѱ־ֵд1.
 ********************************/
void PMU_WKPFLAG_WKPxF_ClrEx(uint32_t NWKPinDef)
{
	PMU->WKPFLAG = NWKPinDef;
}
/********************************
ȡNWKUPx Pinѱ־
:ȡNWKUPx Pinѱ־
NWKUPx Pinѱ־ֵ
 ********************************/
FlagStatus PMU_WKPFLAG_WKPxF_ChkEx(uint32_t NWKPinDef)
{
	if (PMU->WKPFLAG & NWKPinDef)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
͹ģʽĳʼ
:͹ģʽ¸ãSLEEPģʽRAMãں˵ѹ·ȡ
룺͹Ĺܿǰ.
 ********************************/
void PMU_SleepCfg_Init(PMU_SleepCfg_InitTypeDef* SleepCfg_InitStruct)
{
	PMU_LPMCFG_SLPDP_Set(SleepCfg_InitStruct->SLPDP);				/*!<DeepSleepƼĴ  */
	PMU_LPMCFG_DSLPRAM_EXT_Set(SleepCfg_InitStruct->DSLPRAM_EXT);	/*!<DeepSleepģʽRAMݱ  */	
	PMU_LPMCFG_CVS_Setable(SleepCfg_InitStruct->CVS);				/*!<ں˵ѹʹܿ  */	
	PMU_LPMCFG_XTOFF_Set(SleepCfg_InitStruct->XTOFF);				/*!<رXTLFSLEEP/DEEPSLEEP  */
	SCB->SCR = SleepCfg_InitStruct->SCR;							/*!<M0ϵͳƼĴһΪ0  */
	PMU_LPMCFG_PMOD_Set(SleepCfg_InitStruct->PMOD);					/*!<͹ģʽ  */	
}
