/**
  ******************************************************************************
  * @file    fm33a0xx_trng.h
  * @author  FM33a0xx Application Team
  * @version V3.00
  * @date    
  * @brief   This file contains all the functions prototypes for the RCC firmware library.  
  ******************************************************************************
  */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __FM33A0XX_TRNG_H
#define __FM33A0XX_TRNG_H

#ifdef __cplusplus
 extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "FM33A0XX.h"
	 
/* TRNG غ */
extern void ANAC_TRNGCON_TRNGEN_Setable(FunState NewState);
extern FunState ANAC_TRNGCON_TRNGEN_Getable(void);
	 
#define TRNG_TRNGCON_RNGEN_Setable ANAC_TRNGCON_TRNGEN_Setable
#define TRNG_TRNGCON_RNGEN_Getable ANAC_TRNGCON_TRNGEN_Getable
/* Exported constants --------------------------------------------------------*/
/* Exported types ------------------------------------------------------------*/

//Macro_START
//2018-04-02-13-22-21
//FM33A0XX_Driver_Gen_V1.4

#define	TRNG_TRNGCON_RNGEN_Pos	0	/* RNGʹܼĴд1ʹ */
#define	TRNG_TRNGCON_RNGEN_Msk	(0x1U << TRNG_TRNGCON_RNGEN_Pos)
	/* 0رRNG */
	/* 1ʹRNG */

#define	TRNG_RNGOUT_RNGOUT_Pos	0	/* ɽCRCĴ */
#define	TRNG_RNGOUT_RNGOUT_Msk	(0xffffffffU << TRNG_RNGOUT_RNGOUT_Pos)

#define	TRNG_RNGIE_RNGIE_Pos	0	/* ʧжʹܼĴ
 */
#define	TRNG_RNGIE_RNGIE_Msk	(0x1U << TRNG_RNGIE_RNGIE_Pos)
	/* 0ֹʧж */
	/* 1ʹʧж */

#define	TRNG_RNGIF_LFSREN_Pos	1	/* LFSRʹܱ־,Ĵģжϣѯ */
#define	TRNG_RNGIF_LFSREN_Msk	(0x1U << TRNG_RNGIF_LFSREN_Pos)

#define	TRNG_RNGIF_RNF_Pos	0	/* ʧܱ־д10 */
#define	TRNG_RNGIF_RNF_Msk	(0x1U << TRNG_RNGIF_RNF_Pos)

#define	TRNG_CRCCON_CRCEN_Pos	0	/* CRCƼĴ */
#define	TRNG_CRCCON_CRCEN_Msk	(0x1U << TRNG_CRCCON_CRCEN_Pos)
	/* 0CRCر */
	/* 1CRCʹ */

#define	TRNG_CRCIN_CRCIN_Pos	0	/* CRCĴ */
#define	TRNG_CRCIN_CRCIN_Msk	(0xffffffffU << TRNG_CRCIN_CRCIN_Pos)

#define	TRNG_CRCFLAG_CRCD_Pos	0	/* CRCɱ־д0 */
#define	TRNG_CRCFLAG_CRCD_Msk	(0x1U << TRNG_CRCFLAG_CRCD_Pos)
//Macro_End

/* Exported functions --------------------------------------------------------*/ 
extern void TRNG_Deinit(void);

///* RNGʹܼĴд1ʹ غ */
//extern void TRNG_TRNGCON_RNGEN_Setable(FunState NewState);
//extern FunState TRNG_TRNGCON_RNGEN_Getable(void);

/* ɽCRCĴ غ */
extern uint32_t TRNG_RNGOUT_Read(void);

/* ʧжʹܼĴ
 غ */
extern void TRNG_RNGIE_RNGIE_Setable(FunState NewState);
extern FunState TRNG_RNGIE_RNGIE_Getable(void);

/* LFSRʹܱ־,Ĵģжϣѯ غ */
extern FlagStatus TRNG_RNGIF_LFSREN_Chk(void);

/* ʧܱ־д10 غ */
extern void TRNG_RNGIF_RNF_Clr(void);
extern FlagStatus TRNG_RNGIF_RNF_Chk(void);

/* CRCƼĴ غ */
extern void TRNG_CRCCON_CRCEN_Setable(FunState NewState);
extern FunState TRNG_CRCCON_CRCEN_Getable(void);

/* CRCĴ غ */
extern void TRNG_CRCIN_Write(uint32_t SetValue);
extern uint32_t TRNG_CRCIN_Read(void);

/* CRCɱ־д0 غ */
extern void TRNG_CRCFLAG_CRCD_Clr(void);
extern FlagStatus TRNG_CRCFLAG_CRCD_Chk(void);
//Announce_End


#ifdef __cplusplus
}
#endif

#endif 



/************************ (C) COPYRIGHT FMSHelectronics *****END OF FILE****/



